diff --git a/configure.ac b/configure.ac
index d77b909..dbf7d99 100644
--- a/configure.ac
+++ b/configure.ac
@@ -317,8 +317,8 @@ AC_CONFIG_FILES([Makefile
 		 test/validation/random/Makefile
 		 test/validation/scheduler/Makefile
 		 test/validation/synchronizers/Makefile
-		 test/validation/system/Makefile
 		 test/validation/thread/Makefile
+		 test/validation/time/Makefile
 		 test/miscellaneous/Makefile
 		 ])
 
diff --git a/platform/linux-generic/test/Makefile.am b/platform/linux-generic/test/Makefile.am
index 4a112e9..e9c00fe 100644
--- a/platform/linux-generic/test/Makefile.am
+++ b/platform/linux-generic/test/Makefile.am
@@ -18,8 +18,8 @@ TESTS = pktio/pktio_run \
 	${top_builddir}/test/validation/random/random_main$(EXEEXT) \
 	${top_builddir}/test/validation/scheduler/scheduler_main$(EXEEXT) \
 	${top_builddir}/test/validation/synchronizers/synchronizers_main$(EXEEXT) \
-	${top_builddir}/test/validation/system/system_main$(EXEEXT) \
-	${top_builddir}/test/validation/thread/thread_main$(EXEEXT)
+	${top_builddir}/test/validation/thread/thread_main$(EXEEXT) \
+	${top_builddir}/test/validation/time/time_main$(EXEEXT)
 
 SUBDIRS = $(ODP_MODULES)
 endif
diff --git a/test/validation/Makefile.am b/test/validation/Makefile.am
index 9b151ba..7add2e6 100644
--- a/test/validation/Makefile.am
+++ b/test/validation/Makefile.am
@@ -36,7 +36,7 @@ ODP_MODULES = buffer \
 	      random \
 	      scheduler \
 	      synchronizers \
-	      system \
-	      thread
+	      thread \
+	      time
 
 SUBDIRS = common $(ODP_MODULES)
diff --git a/test/validation/system/.gitignore b/test/validation/system/.gitignore
deleted file mode 100644
index 3646b59..0000000
--- a/test/validation/system/.gitignore
+++ /dev/null
@@ -1,2 +0,0 @@
-system_main
-libsystem.a
diff --git a/test/validation/time/.gitignore b/test/validation/time/.gitignore
new file mode 100644
index 0000000..0bc4759
--- /dev/null
+++ b/test/validation/time/.gitignore
@@ -0,0 +1,2 @@
+time_main
+libtime.a
diff --git a/test/validation/system/Makefile.am b/test/validation/time/Makefile.am
similarity index 11%
rename from test/validation/system/Makefile.am
rename to test/validation/time/Makefile.am
index f68fe77..fb53959 100644
--- a/test/validation/system/Makefile.am
+++ b/test/validation/time/Makefile.am
@@ -1,8 +1,8 @@
 include ../Makefile.inc
 
-noinst_LIBRARIES = libsystem.a
-libsystem_a_SOURCES = system.c
+noinst_LIBRARIES = libtime.a
+libtime_a_SOURCES = time.c
 
-bin_PROGRAMS = system_main$(EXEEXT)
-dist_system_main_SOURCES = system_main.c
-system_main_LDADD = libsystem.a $(LIBCUNIT_COMMON) $(LIBODP)
+bin_PROGRAMS = time_main$(EXEEXT)
+dist_time_main_SOURCES = time_main.c
+time_main_LDADD = libtime.a $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/validation/system/system.c b/test/validation/time/time.c
similarity index 72%
rename from test/validation/system/system.c
rename to test/validation/time/time.c
index 5e2d050..0aac599 100644
--- a/test/validation/system/system.c
+++ b/test/validation/time/time.c
@@ -6,13 +6,13 @@
 
 #include <odp.h>
 #include "odp_cunit_common.h"
-#include "system.h"
+#include "time.h"
 
 #define TOLERANCE 1
 #define BUSY_LOOP_CNT 100
 
 /* check that a cycles difference gives a reasonable result */
-static void system_test_odp_cycles_diff(void)
+static void time_test_odp_cycles_diff(void)
 {
 	/* volatile to stop optimization of busy loop */
 	volatile int count = 0;
@@ -32,7 +32,7 @@ static void system_test_odp_cycles_diff(void)
 }
 
 /* check that a negative cycles difference gives a reasonable result */
-static void system_test_odp_cycles_negative_diff(void)
+static void time_test_odp_cycles_negative_diff(void)
 {
 	uint64_t diff, cycles1, cycles2;
 
@@ -43,7 +43,7 @@ static void system_test_odp_cycles_negative_diff(void)
 }
 
 /* check that related conversions come back to the same value */
-static void system_test_odp_time_conversion(void)
+static void time_test_odp_time_conversion(void)
 {
 	uint64_t ns1, ns2, cycles;
 	uint64_t upper_limit, lower_limit;
@@ -61,19 +61,19 @@ static void system_test_odp_time_conversion(void)
 	CU_ASSERT((ns2 <= upper_limit) && (ns2 >= lower_limit));
 }
 
-CU_TestInfo system_suite_time[] = {
-	{"cycles diff", system_test_odp_cycles_diff},
-	{"negative diff", system_test_odp_cycles_negative_diff},
-	{"conversion", system_test_odp_time_conversion},
+CU_TestInfo time_suite_time[] = {
+	{"cycles diff", time_test_odp_cycles_diff},
+	{"negative diff", time_test_odp_cycles_negative_diff},
+	{"conversion", time_test_odp_time_conversion},
 	 CU_TEST_INFO_NULL
 };
 
-static CU_SuiteInfo system_suites[] = {
-		{"Time", NULL, NULL, NULL, NULL, system_suite_time},
+static CU_SuiteInfo time_suites[] = {
+		{"Time", NULL, NULL, NULL, NULL, time_suite_time},
 		 CU_SUITE_INFO_NULL
 };
 
-int system_main(void)
+int time_main(void)
 {
-	return odp_cunit_run(system_suites);
+	return odp_cunit_run(time_suites);
 }
diff --git a/test/validation/system/system.h b/test/validation/time/time.h
similarity index 83%
rename from test/validation/system/system.h
rename to test/validation/time/time.h
index 59fd468..30c2fdc 100644
--- a/test/validation/system/system.h
+++ b/test/validation/time/time.h
@@ -4,4 +4,4 @@
  * SPDX-License-Identifier:     BSD-3-Clause
  */
 
-int system_main(void);
+int time_main(void);
diff --git a/test/validation/system/system_main.c b/test/validation/time/time_main.c
similarity index 75%
rename from test/validation/system/system_main.c
rename to test/validation/time/time_main.c
index 460b635..36cc1dc 100644
--- a/test/validation/system/system_main.c
+++ b/test/validation/time/time_main.c
@@ -4,9 +4,9 @@
  * SPDX-License-Identifier:     BSD-3-Clause
  */
 
-#include "system.h"
+#include "time.h"
 
 int main(void)
 {
-	return system_main();
+	return time_main();
 }