diff --git a/configure.ac b/configure.ac
index 8cfe3e3..b6c6b1e 100644
--- a/configure.ac
+++ b/configure.ac
@@ -323,7 +323,6 @@ AC_CONFIG_FILES([Makefile
 		 doc/implementers-guide/Makefile
 		 doc/users-guide/Makefile
 		 doc/process-guide/Makefile
-		 doc/images/Makefile
 		 doc/application-api-guide/Makefile
 		 example/Makefile
 		 example/classifier/Makefile
diff --git a/doc/Makefile.am b/doc/Makefile.am
index 6f4eac3..e966e95 100644
--- a/doc/Makefile.am
+++ b/doc/Makefile.am
@@ -1,5 +1,5 @@
 SUBDIRS = application-api-guide
 
 if user_guide
-SUBDIRS += images implementers-guide users-guide process-guide
+SUBDIRS += implementers-guide users-guide process-guide
 endif
diff --git a/doc/Makefile.inc b/doc/Makefile.inc
index 3f31e9a..cab5286 100644
--- a/doc/Makefile.inc
+++ b/doc/Makefile.inc
@@ -1,2 +1,6 @@
-.adoc.html:
-	asciidoc -a data-uri -b html5  -a icons -a toc2  -a max-width=55em --out-file=$@ $<
+VPATH=$(top_builddir)/doc/images
+
+.msc.svg:
+	mscgen -T svg -i $^ -o $@
+
+ASCIIDOC_FLAGS =-a data-uri -b html5  -a icons -a toc2  -a max-width=55em
diff --git a/doc/images/Makefile.am b/doc/images/Makefile.am
deleted file mode 100644
index 8fb8a99..0000000
--- a/doc/images/Makefile.am
+++ /dev/null
@@ -1,16 +0,0 @@
-.msc.svg:
-	mscgen -T svg -i $^ -o $@
-
-MSG_SRCS = resource_management.msc
-MSG_TARGETS = $(MSG_SRCS:msc=svg)
-
-EXTRA_DIST = $(MSG_SRCS)
-
-if HAVE_MSCGEN
-TARGETS = $(MSG_TARGETS)
-endif
-
-all-local: $(TARGETS)
-
-clean-local:
-	rm -f $(MSG_TARGETS)
diff --git a/doc/implementers-guide/Makefile.am b/doc/implementers-guide/Makefile.am
index eb614e1..6a614ce 100644
--- a/doc/implementers-guide/Makefile.am
+++ b/doc/implementers-guide/Makefile.am
@@ -1,10 +1,12 @@
 include ../Makefile.inc
 
+SRC    = $(top_srcdir)/doc/implementers-guide/implementers-guide.adoc
 TARGET = implementers-guide.html
 
-EXTRA_DIST = implementers-guide.adoc
+EXTRA_DIST = $(SRC)
 
-all-local: $(TARGET)
+all-local: $(SRC)
+	asciidoc $(ASCIIDOC_FLAGS) --out-file=$(TARGET) $(SRC)
 
 clean-local:
-	rm -f $(TARGET)
+	rm -f  $(builddir)/$(TARGET)
diff --git a/doc/process-guide/Makefile.am b/doc/process-guide/Makefile.am
index 9fc3b80..efef04d 100644
--- a/doc/process-guide/Makefile.am
+++ b/doc/process-guide/Makefile.am
@@ -1,12 +1,19 @@
 include ../Makefile.inc
 
-TARGET = bylaws-guide.html \
-	 release-guide.html
+EXTRA_DIST = $(top_srcdir)/doc/process-guide/bylaws-guide.adoc \
+	     $(top_srcdir)/doc/process-guide/release-guide.adoc
 
-EXTRA_DIST = bylaws-guide.adoc \
-	     release-guide.adoc
-
-all-local: $(TARGET)
+all-local: bylaws-guide.html \
+	   release-guide.html
 
 clean-local:
-	rm -f $(TARGET)
+	rm -f $(builddir)/bylaws-guide.html
+	rm -f $(builddir)/release-guide.html
+
+release-guide.html: $(top_srcdir)/doc/process-guide/release-guide.adoc \
+		    $(top_srcdir)/doc/images/simple_release_git.svg \
+		    $(top_srcdir)/doc/images/release_git.svg
+		    asciidoc $(ASCIIDOC_FLAGS) --out-file=$@ $<
+
+bylaws-guide.html:  $(top_srcdir)/doc/process-guide/bylaws-guide.adoc
+		    asciidoc $(ASCIIDOC_FLAGS) --out-file=$@ $<
diff --git a/doc/users-guide/Makefile.am b/doc/users-guide/Makefile.am
index 960a90f..4f5b1fe 100644
--- a/doc/users-guide/Makefile.am
+++ b/doc/users-guide/Makefile.am
@@ -1,10 +1,26 @@
 include ../Makefile.inc
 
+SRC    = $(top_srcdir)/doc/users-guide/users-guide.adoc
 TARGET = users-guide.html
+IMAGES = $(top_srcdir)/doc/images/overview.svg \
+	 $(top_srcdir)/doc/images/odp_components.svg \
+	 $(top_srcdir)/doc/images/odp_rx_processing.svg \
+	 $(top_srcdir)/doc/images/odp_scheduling.svg \
+	 $(top_srcdir)/doc/images/odp_traffic_manager.svg \
+	 $(top_srcdir)/doc/images/parallel_queue.svg \
+	 $(top_srcdir)/doc/images/atomic_queue.svg \
+	 $(top_srcdir)/doc/images/ordered_queue.svg
 
-EXTRA_DIST = users-guide.adoc
+if HAVE_MSCGEN
+IMAGES += $(top_srcdir)/doc/images/resource_management.svg
+endif
 
-all-local: $(TARGET)
+EXTRA_DIST = $(SRC) $(IMAGES)
+
+all-local: $(SRC)
+	asciidoc $(ASCIIDOC_FLAGS) --out-file=$(TARGET) $(SRC)
 
 clean-local:
-	rm -f $(TARGET)
+	rm -f $(builddir)/$(TARGET)
+
+$(SRC): $(IMAGES)