diff --git a/configure.ac b/configure.ac
index 989ef13..490e19b 100644
--- a/configure.ac
+++ b/configure.ac
@@ -321,7 +321,7 @@ AM_CXXFLAGS="-std=c++11"
 AC_CONFIG_FILES([Makefile
 		 helper/Makefile
 		 helper/test/Makefile
-		 pkgconfig/libodp.pc
+		 pkgconfig/libodp-linux.pc
 		 pkgconfig/libodphelper.pc
 		 scripts/Makefile
 		 ])
diff --git a/doc/implementers-guide/implementers-guide.adoc b/doc/implementers-guide/implementers-guide.adoc
index eba8e52..ca434d6 100644
--- a/doc/implementers-guide/implementers-guide.adoc
+++ b/doc/implementers-guide/implementers-guide.adoc
@@ -114,6 +114,14 @@ After ODP installation (make install), the structure becomes as follows:
     └── odp_drv.h
 ----
 
+== ODP library naming recommendations ==
+
+The ODP project supports two implementations ODP-linux and ODP-DPDK.  The name
+of the libraries are libodp-linux and libodp-dpdk respectively. It is
+recommended that other implementations follow the same schema
+(odp-<implementation name>) to make the representation of the ODP
+implementations uniform in a distribution.
+
 == The validation Suite ==
 
 ODP provides a comprehensive set of API validation tests that are intended to be
diff --git a/example/Makefile.inc b/example/Makefile.inc
index 170f32e..f0bf71d 100644
--- a/example/Makefile.inc
+++ b/example/Makefile.inc
@@ -1,6 +1,6 @@
 include $(top_srcdir)/platform/@with_platform@/Makefile.inc
 LIB   = $(top_builddir)/lib
-LDADD = $(LIB)/libodp.la $(LIB)/libodphelper.la
+LDADD = $(LIB)/libodp-linux.la $(LIB)/libodphelper.la
 AM_CFLAGS += \
 	-I$(srcdir) \
 	-I$(top_srcdir)/example \
diff --git a/helper/test/Makefile.am b/helper/test/Makefile.am
index 656ec7b..0c374e6 100644
--- a/helper/test/Makefile.am
+++ b/helper/test/Makefile.am
@@ -26,8 +26,8 @@ bin_PROGRAMS = $(EXECUTABLES) $(COMPILE_ONLY)
 
 dist_chksum_SOURCES = chksum.c
 dist_thread_SOURCES = thread.c
-thread_LDADD = $(LIB)/libodphelper.la $(LIB)/libodp.la
+thread_LDADD = $(LIB)/libodphelper.la $(LIB)/libodp-linux.la
 dist_process_SOURCES = process.c
 dist_parse_SOURCES = parse.c
-process_LDADD = $(LIB)/libodphelper.la $(LIB)/libodp.la
+process_LDADD = $(LIB)/libodphelper.la $(LIB)/libodp-linux.la
 dist_table_SOURCES = table.c
diff --git a/pkg/debian/control b/pkg/debian/control
index 40b3842..8a1f679 100644
--- a/pkg/debian/control
+++ b/pkg/debian/control
@@ -10,33 +10,33 @@ Homepage: http://www.opendataplane.org/
 Vcs-Git: git://git.linaro.org/lng/odp.git
 Vcs-Browser: https://git.linaro.org/lng/odp.git
 
-Package: odp-bin
+Package: odp-linux-bin
 Section: libdevel
 Architecture: any
 Multi-Arch: allowed
-Depends: libodp (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends: libodp-linux (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Description: Example binaries for OpenDataPlane
  These are the executable examples from the reference implementation.
 
-Package: libodp-dbg
+Package: libodp-linux-dbg
 Priority: extra
 Section: debug
 Architecture: any
 Multi-Arch: same
-Depends: libodp (= ${binary:Version}), ${misc:Depends}
+Depends: libodp-linux (= ${binary:Version}), ${misc:Depends}
 Description: Debug symbols for OpenDataPlane
  This is the OpenDataPlane library from the reference implementation
  with debug turned on.
 
-Package: libodp-dev
+Package: libodp-linux-dev
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libodp (= ${binary:Version}), ${misc:Depends}, libssl-dev
+Depends: libodp-linux (= ${binary:Version}), ${misc:Depends}, libssl-dev
 Description: Development files for OpenDataPlane
  These are the source file for the OpenDataPlane reference implementation.
 
-Package: libodp
+Package: libodp-linux
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
diff --git a/pkg/debian/libodp-dev.install b/pkg/debian/libodp-dev.install
deleted file mode 100644
index b973af4..0000000
--- a/pkg/debian/libodp-dev.install
+++ /dev/null
@@ -1,4 +0,0 @@
-usr/include/*
-usr/lib/*/lib*.so
-usr/lib/*/lib*.a
-usr/lib/*/pkgconfig/*
diff --git a/pkg/debian/libodp-dev.dirs b/pkg/debian/libodp-linux-dev.dirs
similarity index 100%
rename from pkg/debian/libodp-dev.dirs
rename to pkg/debian/libodp-linux-dev.dirs
diff --git a/pkg/debian/libodp-linux-dev.install b/pkg/debian/libodp-linux-dev.install
new file mode 100644
index 0000000..1e47824
--- /dev/null
+++ b/pkg/debian/libodp-linux-dev.install
@@ -0,0 +1,5 @@
+usr/include/odp.h
+usr/include/odp/api/*
+usr/lib/*/libodp-linux.so
+usr/lib/*/libodp-linux.a
+usr/lib/*/pkgconfig/libodp-linux*
diff --git a/pkg/debian/libodp.dirs b/pkg/debian/libodp-linux.dirs
similarity index 100%
rename from pkg/debian/libodp.dirs
rename to pkg/debian/libodp-linux.dirs
diff --git a/pkg/debian/libodp-linux.install b/pkg/debian/libodp-linux.install
new file mode 100644
index 0000000..28ebb93
--- /dev/null
+++ b/pkg/debian/libodp-linux.install
@@ -0,0 +1 @@
+usr/lib/*/libodp-linux.so.*
diff --git a/pkg/debian/libodp.install b/pkg/debian/libodp.install
deleted file mode 100644
index 3ddde58..0000000
--- a/pkg/debian/libodp.install
+++ /dev/null
@@ -1 +0,0 @@
-usr/lib/*/lib*.so.*
diff --git a/pkg/debian/odp-bin.dirs b/pkg/debian/odp-linux-bin.dirs
similarity index 100%
rename from pkg/debian/odp-bin.dirs
rename to pkg/debian/odp-linux-bin.dirs
diff --git a/pkg/debian/odp-bin.install b/pkg/debian/odp-linux-bin.install
similarity index 100%
rename from pkg/debian/odp-bin.install
rename to pkg/debian/odp-linux-bin.install
diff --git a/pkg/debian/rules b/pkg/debian/rules
index 49c5288..be8a2ae 100755
--- a/pkg/debian/rules
+++ b/pkg/debian/rules
@@ -18,4 +18,4 @@ override_dh_auto_configure:
 
 .PHONY: override_dh_strip
 override_dh_strip:
-	dh_strip --dbg-package=libodp-dbg
+	dh_strip --dbg-package=libodp-linux-dbg
diff --git a/pkgconfig/libodp.pc.in b/pkgconfig/libodp-linux.pc.in
similarity index 79%
rename from pkgconfig/libodp.pc.in
rename to pkgconfig/libodp-linux.pc.in
index 7cdf9ea..946f11f 100644
--- a/pkgconfig/libodp.pc.in
+++ b/pkgconfig/libodp-linux.pc.in
@@ -3,9 +3,9 @@ exec_prefix=@exec_prefix@
 libdir=@libdir@
 includedir=@includedir@
 
-Name: libodp
+Name: libodp-linux
 Description: The ODP packet processing engine
 Version: @VERSION@
-Libs: -L${libdir} -lodp
+Libs: -L${libdir} -lodp-linux
 Libs.private:
 Cflags: -I${includedir}
diff --git a/platform/Makefile.inc b/platform/Makefile.inc
index 62375a6..1cb7a71 100644
--- a/platform/Makefile.inc
+++ b/platform/Makefile.inc
@@ -1,14 +1,14 @@
 LIB   = $(top_builddir)/lib
 
-dist_pkgdata_DATA = $(LIB)/libodp.la
+dist_pkgdata_DATA = $(LIB)/libodp-linux.la
 
 pkgconfigdir = $(libdir)/pkgconfig
-pkgconfig_DATA = $(top_builddir)/pkgconfig/libodp.pc
+pkgconfig_DATA = $(top_builddir)/pkgconfig/libodp-linux.pc
 
-.PHONY: pkgconfig/libodp.pc
+.PHONY: pkgconfig/libodp-linux.pc
 
 VPATH = $(srcdir) $(builddir)
-lib_LTLIBRARIES = $(LIB)/libodp.la
+lib_LTLIBRARIES = $(LIB)/libodp-linux.la
 
 AM_LDFLAGS += -version-number '$(ODP_LIBSO_VERSION)'
 
diff --git a/platform/linux-generic/Makefile.am b/platform/linux-generic/Makefile.am
index 04119e2..54f35d6 100644
--- a/platform/linux-generic/Makefile.am
+++ b/platform/linux-generic/Makefile.am
@@ -118,7 +118,7 @@ noinst_HEADERS = \
 		  ${srcdir}/include/odp_traffic_mngr_internal.h \
 		  ${srcdir}/Makefile.inc
 
-__LIB__libodp_la_SOURCES = \
+__LIB__libodp_linux_la_SOURCES = \
 			   odp_atomic.c \
 			   odp_barrier.c \
 			   odp_buffer.c \
@@ -180,5 +180,5 @@ EXTRA_DIST = \
 	     arch/x86/odp_sysinfo_parse.c
 
 if HAVE_PCAP
-__LIB__libodp_la_SOURCES += pktio/pcap.c
+__LIB__libodp_linux_la_SOURCES += pktio/pcap.c
 endif
diff --git a/platform/linux-generic/test/Makefile.inc b/platform/linux-generic/test/Makefile.inc
index 9a7cb6a..13707a7 100644
--- a/platform/linux-generic/test/Makefile.inc
+++ b/platform/linux-generic/test/Makefile.inc
@@ -6,7 +6,7 @@ AM_LDFLAGS += -static
 
 LIBCUNIT_COMMON = $(top_builddir)/test/validation/common/libcunit_common.la
 LIB   = $(top_builddir)/lib
-LIBODP = $(LIB)/libodphelper.la $(LIB)/libodp.la
+LIBODP = $(LIB)/libodphelper.la $(LIB)/libodp-linux.la
 
 INCCUNIT_COMMON = -I$(top_srcdir)/test/validation/common
 INCODP = -I$(top_srcdir)/test \
diff --git a/scripts/builddeb b/scripts/builddeb
index bce74cb..0fa8754 100755
--- a/scripts/builddeb
+++ b/scripts/builddeb
@@ -21,10 +21,10 @@ pushd ${ROOT_DIR}/${package}-${version}
 cp -r ${ROOT_DIR}/pkg/debian .
 
 current=$(echo ${version} | awk -F . '{printf("%d\n", (($1 * 100) + $2))}')
-rename 's,([^-\.]*)(.*),${1}'"${current}"'${2},' debian/*odp*
+rename 's,(.*linux)(.*),${1}'"${current}"'${2},' debian/*odp*-linux.install
 
-sed -i "s:\(.*odp\)\([^\.]\|$\):\1${current}\2:g" debian/control
-sed -i "s:\(.*odp\)\(.*\):\1${current}\2:g" debian/rules
+sed -i "s:\(.*odp-linux\)\([^\.]\|$\):\1${current}\2:g" debian/control
+sed -i "s:\(.*odp-linux\)\(.*\):\1${current}\2:g" debian/rules
 
 if [ $(egrep "\.([a-z0-9]{8}\>|dirty)" .scmversion |wc -l) -gt 0 ]; then
 	export DEBFULLNAME="Donald Duck"
diff --git a/test/Makefile.inc b/test/Makefile.inc
index 183d0a5..b3cb4a5 100644
--- a/test/Makefile.inc
+++ b/test/Makefile.inc
@@ -4,7 +4,7 @@ LIB   = $(top_builddir)/lib
 #in the following line, the libs using the symbols should come before
 #the libs containing them! The includer is given a chance to add things
 #before libodp by setting PRE_LDADD before the inclusion.
-LDADD = $(PRE_LDADD) $(LIB)/libodphelper.la $(LIB)/libodp.la
+LDADD = $(PRE_LDADD) $(LIB)/libodphelper.la $(LIB)/libodp-linux.la
 
 INCFLAGS = -I$(top_srcdir)/test \
 	-I$(top_srcdir)/platform/@with_platform@/include \
diff --git a/test/validation/Makefile.inc b/test/validation/Makefile.inc
index 49efbda..1535926 100644
--- a/test/validation/Makefile.inc
+++ b/test/validation/Makefile.inc
@@ -13,4 +13,4 @@ AM_LDFLAGS += -static
 LIBCUNIT_COMMON = $(COMMON_DIR)/libcunit_common.la
 LIBCPUMASK_COMMON = $(COMMON_DIR)/libcpumask_common.la
 LIBTHRMASK_COMMON = $(COMMON_DIR)/libthrmask_common.la
-LIBODP = $(LIB)/libodphelper.la $(LIB)/libodp.la
+LIBODP = $(LIB)/libodphelper.la $(LIB)/libodp-linux.la